]> git.ipfire.org Git - ipfire-2.x.git/blame - make.sh
Reiser4 Implementation abgeschlossen...
[ipfire-2.x.git] / make.sh
CommitLineData
df5e82b3 1#!/bin/bash
df5e82b3
MT
2############################################################################
3# #
f8e5510c 4# This file is part of the IPFire Firewall. #
df5e82b3 5# #
f8e5510c 6# IPFire is free software; you can redistribute it and/or modify #
df5e82b3
MT
7# it under the terms of the GNU General Public License as published by #
8# the Free Software Foundation; either version 2 of the License, or #
9# (at your option) any later version. #
10# #
f8e5510c 11# IPFire is distributed in the hope that it will be useful, #
df5e82b3
MT
12# but WITHOUT ANY WARRANTY; without even the implied warranty of #
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14# GNU General Public License for more details. #
15# #
16# You should have received a copy of the GNU General Public License #
f8e5510c 17# along with IPFire; if not, write to the Free Software #
df5e82b3
MT
18# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19# #
15679d9f 20# Copyright (C) 2006 IPFire-Team <info@ipfire.eu>. #
df5e82b3
MT
21# #
22############################################################################
df5e82b3
MT
23#
24
15679d9f
MT
25NAME="IPFire" # Software name
26SNAME="ipfire" # Short name
5bd13f01 27VERSION="2.0b" # Version number
8e2e5cf3 28SLOGAN="www.ipfire.org" # Software slogan
15679d9f
MT
29CONFIG_ROOT=/var/ipfire # Configuration rootdir
30NICE=10 # Nice level
857d9bf2 31MAX_RETRIES=1 # prefetch/check loop
15679d9f
MT
32KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33MACHINE=`uname -m`
34SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
c545beb1 36IPFVER="full" # Which versions should be compiled? (full|light|voice|devel)
03ad5f93
MT
37
38# Set an information about the build number
15679d9f
MT
39if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41fi
42
43# Debian specific settings
44if [ ! -e /etc/debian_version ]; then
df5e82b3 45 FULLPATH=`which $0`
15679d9f 46else
df5e82b3
MT
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
15679d9f 53fi
df5e82b3 54
15679d9f
MT
55PWD=`pwd`
56BASENAME=`basename $0`
57BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58LOGFILE=$BASEDIR/log/_build.preparation.log
59export BASEDIR LOGFILE
60DIR_CHK=$BASEDIR/cache/check
61mkdir $BASEDIR/log/ 2>/dev/null
df5e82b3 62
15679d9f
MT
63# Include funtions
64. tools/make-functions
df5e82b3 65
15679d9f
MT
66if [ -f .config ]; then
67 . .config
68else
6b8cff41
MT
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
15679d9f 76fi
df5e82b3
MT
77
78prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
89 exiterror "Not running BASH shell."
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
9b0ff0a0 106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
df5e82b3
MT
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
15679d9f 109 beautify message FAIL
df5e82b3 110 exiterror "Failed to set correct nice level"
15679d9f
MT
111 else
112 beautify message DONE
df5e82b3
MT
113 fi
114
15679d9f 115
df5e82b3
MT
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
9b0ff0a0 121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
df5e82b3 122 if [ `id -u` != 0 ]; then
15679d9f 123 beautify message FAIL
df5e82b3 124 exiterror "Not building as root"
15679d9f
MT
125 else
126 beautify message DONE
df5e82b3
MT
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
9b0ff0a0 135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
df5e82b3
MT
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
41921bd9 138 if (( 2048000 > $BASE_ASPACE )); then
df5e82b3 139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
41921bd9 140 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
15679d9f 141 beautify message FAIL
41921bd9 142 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
df5e82b3 143 fi
15679d9f
MT
144 else
145 beautify message DONE
df5e82b3
MT
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
df5e82b3
MT
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
164 ln -s $BASEDIR/build/tools /
165 fi
166 if [ ! -h /tools ]; then
167 exiterror "Could not create /tools symbolic link."
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
1ee8bf5d 173 MAKETUNING="-j4"
dd714b8a 174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
df5e82b3
MT
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
90d372c4 179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
df5e82b3 180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
90d372c4
MT
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
df5e82b3
MT
185
186 # Make all sources and proc available under lfs build
90d372c4 187 mount --bind /dev $BASEDIR/build/dev
857d9bf2
MT
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
df5e82b3
MT
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
119ee469 202 # This is a temporary hack!!!
6b8cff41
MT
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
119ee469 206
df5e82b3
MT
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213}
214
df5e82b3
MT
215buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
df5e82b3
MT
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
15679d9f
MT
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
df5e82b3 224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
dd714b8a
MT
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
9b0ff0a0 227 lfsmake1 cleanup-toolchain PASS=1
df5e82b3
MT
228 lfsmake1 tcl
229 lfsmake1 expect
df5e82b3 230 lfsmake1 dejagnu
15679d9f
MT
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
dd714b8a
MT
233 lfsmake1 ncurses
234 lfsmake1 bash
df5e82b3 235 lfsmake1 bzip2
dd714b8a 236 lfsmake1 coreutils
df5e82b3
MT
237 lfsmake1 diffutils
238 lfsmake1 findutils
dd714b8a 239 lfsmake1 gawk
df5e82b3 240 lfsmake1 gettext
dd714b8a
MT
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
df5e82b3 245 lfsmake1 patch
dd714b8a
MT
246 lfsmake1 perl
247 lfsmake1 sed
df5e82b3
MT
248 lfsmake1 tar
249 lfsmake1 texinfo
df5e82b3 250 lfsmake1 util-linux
9b0ff0a0 251 lfsmake1 cleanup-toolchain PASS=2
df5e82b3
MT
252 export PATH=$ORG_PATH
253}
254
255buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
df5e82b3 258 lfsmake2 stage2
9b0ff0a0 259 lfsmake2 linux-libc-header
df5e82b3
MT
260 lfsmake2 man-pages
261 lfsmake2 glibc
9b0ff0a0 262 lfsmake2 cleanup-toolchain PASS=3
df5e82b3
MT
263 lfsmake2 binutils
264 lfsmake2 gcc
9b0ff0a0 265 lfsmake2 berkeley
df5e82b3 266 lfsmake2 coreutils
df5e82b3 267 lfsmake2 iana-etc
df5e82b3
MT
268 lfsmake2 m4
269 lfsmake2 bison
9b0ff0a0
MT
270 lfsmake2 ncurses
271 lfsmake2 procps
df5e82b3 272 lfsmake2 sed
9b0ff0a0 273 lfsmake2 libtool
df5e82b3 274 lfsmake2 perl
9b0ff0a0
MT
275 lfsmake2 readline
276 lfsmake2 zlib
df5e82b3
MT
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
df5e82b3
MT
280 lfsmake2 bzip2
281 lfsmake2 diffutils
df5e82b3 282 lfsmake2 e2fsprogs
65998e0a 283 lfsmake2 ed
9b0ff0a0
MT
284 lfsmake2 file
285 lfsmake2 findutils
286 lfsmake2 flex
9b0ff0a0
MT
287 lfsmake2 gawk
288 lfsmake2 gettext
289 lfsmake2 grep
290 lfsmake2 groff
df5e82b3 291 lfsmake2 gzip
9b0ff0a0
MT
292 lfsmake2 inetutils
293 lfsmake2 iproute2
294 lfsmake2 kbd
295 lfsmake2 less
44254afd 296 lfsmake2 libaal
df5e82b3 297 lfsmake2 make
9b0ff0a0
MT
298 lfsmake2 man
299 lfsmake2 mktemp
df5e82b3 300 lfsmake2 modutils
65998e0a 301 lfsmake2 net-tools
df5e82b3 302 lfsmake2 patch
df5e82b3 303 lfsmake2 psmisc
44254afd 304 lfsmake2 reiser4progs
df5e82b3
MT
305 lfsmake2 shadow
306 lfsmake2 sysklogd
307 lfsmake2 sysvinit
308 lfsmake2 tar
90d372c4
MT
309 lfsmake2 texinfo
310 lfsmake2 udev
df5e82b3 311 lfsmake2 util-linux
90d372c4 312 lfsmake2 vim
44254afd 313 lfsmake2 grub
df5e82b3
MT
314}
315
15679d9f 316buildipfire() {
907cd036 317 LOGFILE="$BASEDIR/log/_build.ipfire.log"
df5e82b3 318 export LOGFILE
15679d9f
MT
319 ipfiremake configroot
320 ipfiremake dhcp
321 ipfiremake dhcpcd
322 ipfiremake libusb
323 ipfiremake libpcap
a10ae6cc 324 ipfiremake linux-atm
15679d9f
MT
325 ipfiremake ppp
326 ipfiremake rp-pppoe
327 ipfiremake unzip
3a1019f6 328 ipfiremake linux SMP=1
552b817b 329 ipfiremake ipp2p SMP=1
05207d69
MT
330 ipfiremake fcdsl SMP=1
331 ipfiremake fcdsl2 SMP=1
332 ipfiremake fcdslsl SMP=1
333 ipfiremake fcdslusb SMP=1
334 ipfiremake fcdslslusb SMP=1
335 ipfiremake fcpci SMP=1
a10ae6cc 336# ipfiremake promise-sata-300-tx SMP=1
dd001658 337 ipfiremake zaptel SMP=1
d02350a2 338 ipfiremake fuse SMP=1
c3e36980 339 ipfiremake linux
552b817b 340 ipfiremake ipp2p
05207d69
MT
341 ipfiremake fcdsl
342 ipfiremake fcdsl2
343 ipfiremake fcdslsl
344 ipfiremake fcdslusb
345 ipfiremake fcdslslusb
346 ipfiremake fcpci
f59e1e88 347# ipfiremake promise-sata-300-tx
119f6ad3 348 ipfiremake zaptel
d02350a2 349 ipfiremake fuse
c545beb1 350 ipfiremake pkg-config
15679d9f
MT
351 ipfiremake expat
352 ipfiremake gdbm
353 ipfiremake gmp
c8ead4a5 354 ipfiremake pam
15679d9f
MT
355 ipfiremake openssl
356 ipfiremake python
357 ipfiremake libnet
ddac6087 358 ipfiremake libjpeg
15679d9f
MT
359 ipfiremake libpng
360 ipfiremake libtiff
15679d9f
MT
361 ipfiremake lcms
362 ipfiremake libmng
363 ipfiremake freetype
fd3e7da0 364 ipfiremake libart
15679d9f
MT
365 ipfiremake gd
366 ipfiremake popt
411afd1f 367 ipfiremake pcre
15679d9f
MT
368 ipfiremake slang
369 ipfiremake newt
fd3e7da0 370 ipfiremake libcap
15679d9f 371 ipfiremake pciutils
15679d9f 372 ipfiremake libxml2
6b8cff41 373 ipfiremake BerkeleyDB
15679d9f 374 ipfiremake mysql
411afd1f 375 ipfiremake cyrus-sasl
15679d9f
MT
376 ipfiremake openldap
377 ipfiremake apache2
378 ipfiremake php
a10ae6cc 379 ipfiremake apache2 PASS=C
15679d9f
MT
380 ipfiremake arping
381 ipfiremake beep
382 ipfiremake bind
383 ipfiremake capi4k-utils
384 ipfiremake cdrtools
385 ipfiremake dnsmasq
44254afd 386 ipfiremake libaal
15679d9f 387 ipfiremake dosfstools
72d80898 388 ipfiremake reiserfsprogs
26ec9513 389 ipfiremake squashfstools
d02350a2 390 ipfiremake ntfs-3g
15679d9f
MT
391 ipfiremake ethtool
392 ipfiremake ez-ipupdate
393 ipfiremake fcron
7b9e5f10 394 ipfiremake GD
15679d9f
MT
395 ipfiremake gnupg
396 ipfiremake hdparm
397 ipfiremake ibod
398 ipfiremake initscripts
399 ipfiremake iptables
490256d5 400 ipfiremake libupnp
552b817b 401 ipfiremake ipp2p IPT=1
81a7e7c8 402 ipfiremake moblock
490256d5 403 ipfiremake linux-igd
15679d9f
MT
404 ipfiremake ipac-ng
405 ipfiremake ipaddr
15679d9f 406 ipfiremake iptstate
fd3e7da0 407 ipfiremake iputils
15679d9f 408 ipfiremake l7-protocols
a10ae6cc 409 ipfiremake isapnptools
fe6d84cb 410# ipfiremake isdn4k-utils # What about mISDN???
72d80898 411 ipfiremake kudzu
15679d9f
MT
412 ipfiremake logrotate
413 ipfiremake logwatch
15679d9f
MT
414 ipfiremake misc-progs
415 ipfiremake mtools
416 ipfiremake nano
417 ipfiremake nash
418 ipfiremake nasm
419 ipfiremake URI
420 ipfiremake HTML-Tagset
421 ipfiremake HTML-Parser
422 ipfiremake Compress-Zlib
423 ipfiremake Digest
424 ipfiremake Digest-SHA1
425 ipfiremake Digest-HMAC
426 ipfiremake libwww-perl
427 ipfiremake Net-DNS
428 ipfiremake Net-IPv4Addr
429 ipfiremake Net_SSLeay
430 ipfiremake IO-Stringy
431 ipfiremake Unix-Syslog
432 ipfiremake Mail-Tools
433 ipfiremake MIME-Tools
434 ipfiremake Net-Server
435 ipfiremake Convert-TNEF
436 ipfiremake Convert-UUlib
437 ipfiremake Archive-Tar
438 ipfiremake Archive-Zip
439 ipfiremake Text-Tabs+Wrap
440 ipfiremake Locale-Country
441 ipfiremake GeoIP
442 ipfiremake fwhits
443 ipfiremake noip_updater
444 ipfiremake ntp
445 ipfiremake oinkmaster
446 ipfiremake openssh
447 ipfiremake openswan
448 ipfiremake pptpclient
449 ipfiremake rrdtool
450 ipfiremake setserial
451 ipfiremake setup
452 ipfiremake snort
453 ipfiremake squid
454 ipfiremake squid-graph
455 ipfiremake squidguard
6f00de0d 456 ipfiremake tcpdump
15679d9f
MT
457 ipfiremake traceroute
458 ipfiremake vlan
459 ipfiremake wireless
460 ipfiremake libsafe
461 ipfiremake 3c5x9setup
462 ipfiremake pakfire
15679d9f
MT
463 ipfiremake java
464 ipfiremake bootsplash
465 ipfiremake spandsp
466 ipfiremake lzo
467 ipfiremake openvpn
15679d9f 468 ipfiremake glib
15679d9f 469 ipfiremake pammysql
15679d9f
MT
470 ipfiremake xinetd
471 ipfiremake ghostscript
472 ipfiremake cups
473 ipfiremake samba
474 ipfiremake sudo
475 ipfiremake mc
476 ipfiremake wget
477 ipfiremake wput
478 ipfiremake bridge-utils
479 ipfiremake screen
480 ipfiremake hddtemp
481 ipfiremake smartmontools
482 ipfiremake htop
483 ipfiremake lynx
484 ipfiremake postfix
485 ipfiremake procmail
486 ipfiremake fetchmail
487 ipfiremake cyrusimap
488 ipfiremake webcyradm
489 ipfiremake mailx
490 ipfiremake clamav
491 ipfiremake razor
492 ipfiremake spamassassin
fd3e7da0 493 ipfiremake amavisd
15679d9f 494 ipfiremake stund
15679d9f 495 ipfiremake libpri
119f6ad3 496# ipfiremake bristuff
15679d9f
MT
497 ipfiremake asterisk
498 ipfiremake mpg123
499 ipfiremake libmad
500 ipfiremake libogg
501 ipfiremake libvorbis
502 ipfiremake lame
503 ipfiremake xvid
504 ipfiremake mpeg2dec
505 ipfiremake ffmpeg
506 ipfiremake sox
507 ipfiremake gnump3d
508 ipfiremake videolan
509 ipfiremake applejuice
510 ipfiremake ocaml
511 ipfiremake mldonkey
512 ipfiremake ntop
513 ipfiremake rsync
514 ipfiremake tcpwrapper
515 ipfiremake portmap
516 ipfiremake nfs
517 ipfiremake nmap
518 ipfiremake mbmon
519 ipfiremake iftop
520 ipfiremake ncftp
521 ipfiremake cftp
522 ipfiremake etherwake
523 ipfiremake ethereal
524 ipfiremake tftp-hpa
525 ipfiremake iptraf
526 ipfiremake nagios
df5e82b3
MT
527}
528
529buildinstaller() {
530 # Run installer scripts one by one
531 LOGFILE="$BASEDIR/log/_build.installer.log"
532 export LOGFILE
0afc6d83 533 ipfiremake syslinux
fd0763dc 534 ipfiremake memtest
bc9f0c12
MT
535 installmake linux-libc-header
536 installmake binutils
537 ipfiremake uClibc PASS=1
538 ipfiremake gcc INST=1
539 installmake uClibc PASS=2
540 installmake gcc INST=2
541 installmake uClibc PASS=3
df5e82b3 542 installmake busybox
c66941dd 543 installmake udev
33634aa8
MT
544 installmake slang
545 installmake newt
72d80898 546 installmake gettext
33634aa8
MT
547 installmake kbd
548 installmake popt
33634aa8 549 installmake sysvinit
df5e82b3 550 installmake misc-progs
33634aa8 551 installmake e2fsprogs
44254afd
MT
552 installmake libaal
553 installmake reiser4progs
89069053 554 installmake reiserfsprogs
a6316ce4 555 installmake sysfsutils
df5e82b3 556 installmake util-linux
df5e82b3 557 installmake pciutils
fcb5057d 558 installmake kudzu
df5e82b3 559 installmake installer
df5e82b3 560 installmake initrd
df5e82b3
MT
561}
562
563buildpackages() {
564 LOGFILE="$BASEDIR/log/_build.packages.log"
565 export LOGFILE
566 echo "... see detailed log in _build.*.log files" >> $LOGFILE
0fbb45e9 567
edd536b6 568 installmake strip
df5e82b3
MT
569
570 # Generating list of packages used
0fbb45e9 571 echo -n "Generating packages list from logs" | tee -a $LOGFILE
df5e82b3
MT
572 rm -f $BASEDIR/doc/packages-list
573 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
574 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
7471f6ab 575 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
df5e82b3
MT
576 fi
577 done
7471f6ab 578 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
0fbb45e9 579 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$' \
df5e82b3
MT
580 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
581 rm -f $BASEDIR/doc/packages-list
c9673262 582 # packages-list.txt is ready to be displayed for wiki page
0fbb45e9 583 beautify message DONE
df5e82b3 584
9607771a 585 # Create images for install
97de2cae
MT
586 for i in $IPFVER
587 do
81a7e7c8 588 if [ $i == "devel" ]; then
aa2870e6 589 if [ ! -e ipfire-$VERSION.i586-devel.iso ]; then
81a7e7c8
MT
590 ipfiremake cdrom ED=$i
591 fi
592 else
593 ipfiremake cdrom ED=$i
594 fi
97de2cae 595 done
33634aa8 596 ipfiremake pxe
fcb5057d 597 cp -f $LFS/install/images/{*.iso,*.tgz} $BASEDIR >> $LOGFILE 2>&1
c9673262 598
72d80898 599# ipfirepackages
e67a57fe
MT
600
601 # Cleanup
602 stdumount
603 rm -rf $BASEDIR/build/tmp/*
604
605 # Generating total list of files
fd0763dc 606 echo "Generating files list from logs" | tee -a $LOGFILE
e67a57fe
MT
607 rm -f $BASEDIR/log/FILES
608 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
609 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
610 echo "##" >>$BASEDIR/log/FILES
611 echo "## `basename $i`" >>$BASEDIR/log/FILES
612 echo "##" >>$BASEDIR/log/FILES
613 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
614 fi
615 done
913668ba 616 cd $BASEDIR/packages; ls -w1 *.ipfire | awk -F ".ipfire" '{ print $1 }' > $BASEDIR/packages/packages_list.txt
5e773594 617 echo -n "###EOF###" >> $BASEDIR/packages/packages_list.txt
e67a57fe
MT
618
619 cd $PWD
620
621}
622
623ipfirepackages() {
013a23e2
MT
624 if [ -d "$BASEDIR/packages" ]; then
625 for i in `ls $BASEDIR/packages`; do
626 touch $BASEDIR/build/install/packages/$i.empty
627 done
628 fi
f1baee3e 629# ipfiredist amavisd
78331e30 630 ipfiredist applejuice
5ac2da9f 631 ipfiredist asterisk
c7acba4a 632 ipfiredist clamav
483f59cd 633 ipfiredist cups
78331e30
MT
634 ipfiredist cyrusimap
635 ipfiredist fetchmail
d1b6aa72 636 ipfiredist ffmpeg
78331e30 637 ipfiredist gnump3d
7a98bae5 638 ipfiredist iptraf
0d0521b6 639 ipfiredist java
78331e30 640 ipfiredist lame
d1b6aa72 641 ipfiredist libmad
ae179f6e 642 ipfiredist libogg
ae179f6e 643 ipfiredist libvorbis
f0ca8c34 644 ipfiredist mailx
3ab910dd 645 ipfiredist mldonkey
d1b6aa72 646 ipfiredist mpeg2dec
2ae94d2d 647 ipfiredist nagios
f0ca8c34
MT
648 ipfiredist nfs
649 ipfiredist nmap
3e45cc09 650 ipfiredist ntop
27ac55bf 651 ipfiredist portmap
78331e30 652 ipfiredist postfix
371d9df0 653 ipfiredist procmail
90350ff3 654 ipfiredist samba
ae179f6e 655 ipfiredist sox
f0ca8c34 656 ipfiredist spamassassin
7a98bae5 657 ipfiredist subversion
d1b6aa72 658 ipfiredist videolan
f1baee3e 659 ipfiredist webcyradm
d1b6aa72 660 ipfiredist xvid
0145f271 661 ipfiredist yasuc
78331e30 662 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
d535503d 663 mv -f $LFS/install/packages/*.{ipfire,md5} $BASEDIR/packages >> $LOGFILE 2>&1
483f59cd 664 rm -rf $BASEDIR/build/install/packages/*
df5e82b3
MT
665}
666
667# See what we're supposed to do
668case "$1" in
669build)
9729e787 670 clear
df5e82b3 671 BUILDMACHINE=`uname -m`
712d859c 672 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
df5e82b3 673 #only restore on a clean disk
9b0ff0a0 674 if [ ! -f log/cleanup-toolchain-2-tools ]; then
df5e82b3 675 if [ ! -n "$PACKAGE" ]; then
15679d9f 676 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
df5e82b3
MT
677 prepareenv
678 buildtoolchain
679 else
680 PACKAGENAME=${PACKAGE%.tar.gz}
15679d9f 681 beautify build_stage "Packaged toolchain compilation"
df5e82b3
MT
682 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
683 tar zxf $PACKAGE
684 prepareenv
685 else
686 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
687 fi
688 fi
689 else
9729e787
MT
690 echo -n "Using installed toolchain" | tee -a $LOGFILE
691 beautify message SKIP
df5e82b3
MT
692 prepareenv
693 fi
5cfe86e6 694
7ab7a9b4 695 beautify build_start
0b59f25c 696 beautify build_stage "Building LFS"
df5e82b3 697 buildbase
15679d9f 698
0b59f25c 699 beautify build_stage "Building IPFire"
15679d9f 700 buildipfire
5cfe86e6
HS
701
702 # Setzen des IPFire Builds
8af06406 703 if [ "$FIREBUILD" ]; then
e57bc1fd 704 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
5cfe86e6 705 else
e57bc1fd 706 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
5cfe86e6
HS
707 fi
708
0b59f25c 709 beautify build_stage "Building installer"
df5e82b3 710 buildinstaller
15679d9f 711
0b59f25c 712 beautify build_stage "Building packages"
df5e82b3 713 buildpackages
7ab7a9b4 714 beautify build_end
df5e82b3
MT
715 ;;
716shell)
717 # enter a shell inside LFS chroot
718 # may be used to changed kernel settings
719 prepareenv
720 entershell
721 ;;
722changelog)
d1dd6669 723 echo -n "Loading new Changelog from SVN: "
223ad6a4 724 svn log http://svn.ipfire.org/svn/ipfire > doc/ChangeLog
a50d04ab 725 beautify message DONE
df5e82b3 726 ;;
df5e82b3 727clean)
a50d04ab 728 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
df5e82b3
MT
729 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
730 $LOSETUP -d $i 2>/dev/null
731 done
732 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
733 umount $i
734 done
735 stdumount
736 for i in `seq 0 7`; do
737 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
738 umount /dev/loop${i} 2>/dev/null;
739 losetup -d /dev/loop${i} 2>/dev/null;
740 fi;
741 done
742 rm -rf $BASEDIR/build
743 rm -rf $BASEDIR/cdrom
f9315063 744 rm -rf $BASEDIR/packages
df5e82b3 745 rm -rf $BASEDIR/log
df5e82b3
MT
746 if [ -h /tools ]; then
747 rm -f /tools
748 fi
a50d04ab 749 beautify message DONE
df5e82b3 750 ;;
c3db995c 751downloadsrc)
df5e82b3
MT
752 if [ ! -d $BASEDIR/cache ]; then
753 mkdir $BASEDIR/cache
754 fi
755 mkdir -p $BASEDIR/log
857d9bf2 756 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
df5e82b3
MT
757 FINISHED=0
758 cd $BASEDIR/lfs
759 for c in `seq $MAX_RETRIES`; do
760 if (( FINISHED==1 )); then
761 break
762 fi
763 FINISHED=1
764 cd $BASEDIR/lfs
765 for i in *; do
766 if [ -f "$i" -a "$i" != "Config" ]; then
e22c7973 767 echo -ne "Loading $i"
df5e82b3
MT
768 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
769 if [ $? -ne 0 ]; then
e22c7973 770 beautify message FAIL
df5e82b3
MT
771 FINISHED=0
772 else
773 if [ $c -eq 1 ]; then
e22c7973 774 beautify message DONE
df5e82b3
MT
775 fi
776 fi
777 fi
778 done
779 done
e22c7973 780 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
df5e82b3
MT
781 ERROR=0
782 for i in *; do
783 if [ -f "$i" -a "$i" != "Config" ]; then
784 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
785 if [ $? -ne 0 ]; then
e22c7973
MT
786 echo -ne "MD5 difference in lfs/$i"
787 beautify message FAIL
df5e82b3
MT
788 ERROR=1
789 fi
790 fi
791 done
792 if [ $ERROR -eq 0 ]; then
e22c7973
MT
793 echo -ne "${BOLD}all files md5sum match${NORMAL}"
794 beautify message DONE
795 else
796 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
797 beautify message FAIL
df5e82b3 798 fi
e22c7973 799 cd - >/dev/null 2>&1
df5e82b3 800 ;;
df5e82b3 801toolchain)
9729e787 802 clear
df5e82b3 803 prepareenv
15679d9f 804 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
df5e82b3
MT
805 buildtoolchain
806 BUILDMACHINE=`uname -m`
807 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
712d859c
MT
808 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
809 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
df5e82b3
MT
810 build/{bin,etc,usr/bin,usr/local} \
811 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
812 log >> $LOGFILE
712d859c
MT
813 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
814 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
df5e82b3
MT
815 stdumount
816 ;;
817gettoolchain)
818 BUILDMACHINE=`uname -m`
819 # arbitrary name to be updated in case of new toolchain package upload
c6cb9d25 820 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
712d859c 821 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
5bd13f01 822 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
712d859c
MT
823 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
824 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
825 cd $BASEDIR/cache/toolchains
5bd13f01 826 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
712d859c
MT
827 if [ $? -ne 0 ]; then
828 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
40a4ea4c 829 else
712d859c
MT
830 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
831 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
832 else
833 exiterror "$PACKAGE.md5 did not match, check downloaded package"
834 fi
40a4ea4c 835 fi
712d859c
MT
836 else
837 echo "Toolchain is already downloaded. Exiting..."
df5e82b3
MT
838 fi
839 ;;
15679d9f 840othersrc)
ce56e927 841 prepareenv
15679d9f 842 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
ce56e927
MT
843 chroot $LFS /tools/bin/env -i HOME=/root \
844 TERM=$TERM PS1='\u:\w\$ ' \
845 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
846 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
847 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
848 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
15679d9f
MT
849 if [ $? -eq "0" ]; then
850 beautify message DONE
851 else
852 beautify message FAIL
853 fi
ce56e927
MT
854 stdumount
855 ;;
c6cb9d25
MT
856svn)
857 case "$2" in
858 update|up)
cc0e56be 859 # clear
15679d9f 860 echo -ne "Loading the latest source files...\n"
7471f6ab
MT
861 if [ $3 ]; then
862 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
863 else
864 svn update | tee -a $PWD/log/_build.svn.update.log
865 fi
15679d9f
MT
866 if [ $? -eq "0" ]; then
867 beautify message DONE
c6cb9d25 868 else
15679d9f 869 beautify message FAIL
c6cb9d25
MT
870 exit 1
871 fi
15679d9f 872 echo -ne "Writing the svn-info to a file"
c6cb9d25 873 svn info > $PWD/svn_status
15679d9f
MT
874 if [ $? -eq "0" ]; then
875 beautify message DONE
c6cb9d25 876 else
15679d9f 877 beautify message FAIL
c6cb9d25
MT
878 exit 1
879 fi
712d859c 880 chmod 755 $0
cc0e56be 881 exit 0
c6cb9d25
MT
882 ;;
883 commit|ci)
884 clear
6b8cff41
MT
885 if [ -f /usr/bin/mcedit ]; then
886 export EDITOR=/usr/bin/mcedit
73d9a908
MT
887 fi
888 if [ -f /usr/bin/nano ]; then
889 export EDITOR=/usr/bin/nano
6b8cff41
MT
890 fi
891 echo -ne "Selecting editor $EDITOR..."
892 beautify message DONE
d79b46cb 893 if [ -e /sbin/yast ]; then
028698e8
MT
894 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
895 $0 changelog
896 fi
d79b46cb 897 fi
15679d9f 898 svn commit
c6cb9d25 899 $0 svn up
6b8cff41 900 $0 uploadsrc
c6cb9d25
MT
901 ;;
902 dist)
7471f6ab
MT
903 if [ $3 ]; then
904 SVN_REVISION=$3
905 fi
906 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
907 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
908 exit 0
909 fi
910 echo -en "REV $SVN_REVISION: Downloading..."
223ad6a4
MT
911 svn export http://svn.ipfire.org/svn/ipfire/trunk ipfire-source/ --force > /dev/null
912 svn log http://svn.ipfire.org/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
913 #svn info http://svn.ipfire.org/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
15679d9f
MT
914 evaluate 1
915
7471f6ab
MT
916 echo -en "REV $SVN_REVISION: Compressing files..."
917 if [ -e ipfire-source/trunk/make.sh ]; then
918 chmod 755 ipfire-source/trunk/make.sh
919 fi
9dc02b38 920 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
15679d9f 921 evaluate 1
7471f6ab 922 echo -en "REV $SVN_REVISION: Cleaning up..."
c6cb9d25 923 rm ipfire-source/ -r
15679d9f 924 evaluate 1
7471f6ab 925 ;;
028698e8 926 diff|di)
15679d9f 927 echo -ne "Make a local diff to last svn revision"
c6cb9d25 928 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
15679d9f 929 evaluate 1
c6cb9d25
MT
930 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
931 ;;
932 esac
f9315063 933 ;;
15679d9f
MT
934uploadsrc)
935 PWD=`pwd`
936 cd $BASEDIR/cache/
937 echo -e "Uploading cache to ftp server:"
6fb8ec08 938 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL$FTP_CACHE_PATH/ > /tmp/ftplist
15679d9f 939 for i in *; do
f59e1e88 940 if [ "$i" == "toolchains" ]; then continue; fi
6fb8ec08 941 grep -q $i /tmp/ftplist
0eab8e84 942 if [ "$?" -ne "0" ]; then
15679d9f 943 echo -ne "$i"
71e32384 944 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $i
6fb8ec08 945 if [ "$?" -ne "0" ]; then
15679d9f 946 beautify message FAIL
0eab8e84
MT
947 fi
948 fi
949 done
6fb8ec08 950 rm -f /tmp/ftplist
15679d9f
MT
951 cd $PWD
952 exit 0
0eab8e84 953 ;;
cc0e56be
MT
954upload)
955 case "$2" in
956 iso)
957 echo -e "Uploading the iso to $IPFIRE_FTP_URL_EXT."
9dc02b38
MT
958 cat <<EOF > .ftp-commands
959mkdir $IPFIRE_FTP_PATH_EXT
960ls -lah
961quit
962EOF
963 ncftp -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT < .ftp-commands
964 rm -f .ftp-commands
965 md5sum ipfire-install-$VERSION.i386.iso > ipfire-install-$VERSION.i386.iso.md5
71e32384
MT
966 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ ipfire-install-$VERSION.i386.iso
967 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ ipfire-install-$VERSION.i386.iso.md5
968 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ ipfire-source-r$SVN_REVISION.tar.gz
969 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ svn_status
9dc02b38
MT
970 if [ "$?" -eq "0" ]; then
971 echo -e "The iso of Revision $SVN_REVISION was successfully uploaded to $IPFIRE_FTP_URL_EXT$IPFIRE_FTP_PATH_EXT/."
cc0e56be 972 else
9dc02b38
MT
973 echo -e "There was an error while uploading the iso to the ftp server."
974 exit 1
cc0e56be 975 fi
6aae8d61 976 if [ "$3" = "--with-sources-cd" ]; then
71e32384 977 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ ipfire-sources-cd-$VERSION.$MACHINE.iso
6aae8d61 978 fi
cc0e56be
MT
979 ;;
980 paks)
9dc02b38
MT
981 cat <<EOF > .ftp-commands
982mkdir $IPFIRE_FTP_PATH_PAK
983ls -lah
984quit
985EOF
986 ncftp -u $IPFIRE_FTP_USER_PAK -p $IPFIRE_FTP_PASS_PAK $IPFIRE_FTP_URL_PAK < .ftp-commands
987 rm -f .ftp-commands
cc0e56be
MT
988 ncftpput -z -u $IPFIRE_FTP_USER_PAK -p $IPFIRE_FTP_PASS_PAK $IPFIRE_FTP_URL_PAK $IPFIRE_FTP_PATH_PAK/ packages/*
989 if [ "$?" -eq "0" ]; then
9dc02b38 990 echo -e "The packages were successfully uploaded to $IPFIRE_FTP_URL_PAK$IPFIRE_FTP_PATH_PAK/."
cc0e56be
MT
991 else
992 echo -e "There was an error while uploading the packages to the ftp server."
712d859c 993 exit 1
cc0e56be
MT
994 fi
995 ;;
996 esac
0d0521b6 997 ;;
cc0e56be 998batch)
c8582074 999 if [ "$2" = "--background" ]; then
15679d9f
MT
1000 batch_script
1001 exit $?
1002 fi
27ac55bf 1003 if [ `screen -ls | grep -q ipfire` ]; then
712d859c
MT
1004 echo "Build is already running, sorry!"
1005 exit 1
1006 else
27ac55bf
MT
1007 if [ "$2" = "--rebuild" ]; then
1008 export IPFIRE_REBUILD=1
1009 echo "REBUILD!"
1010 else
1011 export IPFIRE_REBUILD=0
1012 fi
15679d9f
MT
1013 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
1014 screen -dmS ipfire $0 batch --background
1015 evaluate 1
712d859c
MT
1016 exit 0
1017 fi
cc0e56be 1018 ;;
028698e8 1019watch)
15679d9f 1020 watch_screen
028698e8 1021 ;;
33634aa8
MT
1022pxe)
1023 case "$2" in
1024 start)
1025 start_tftpd
1026 ;;
1027 stop)
1028 stop_tftpd
1029 ;;
a50d04ab 1030 reload|restart)
33634aa8
MT
1031 reload_tftpd
1032 ;;
1033 esac
1034 exit 0
1035 ;;
6b8cff41 1036"")
24a4a744
MT
1037 clear
1038 svn info
c3db995c 1039 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
24a4a744
MT
1040 do
1041 case $name in
c3db995c
MT
1042 "IPFIRE: Downloadsrc")
1043 $0 downloadsrc
c6cb9d25
MT
1044 ;;
1045 "IPFIRE: Build (silent)")
1046 $0 build-silent
1047 ;;
1048 "IPFIRE: Watch Build")
028698e8 1049 $0 watch
c6cb9d25 1050 ;;
712d859c
MT
1051 "IPFIRE: Batch")
1052 $0 batch
1053 ;;
c6cb9d25
MT
1054 "IPFIRE: Clean")
1055 $0 clean
1056 ;;
c6cb9d25
MT
1057 "SVN: Update")
1058 $0 svn update
1059 ;;
c6cb9d25 1060 "Help")
a50d04ab 1061 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
c6cb9d25
MT
1062 cat doc/make.sh-usage
1063 ;;
712d859c
MT
1064 "LOG: Tail")
1065 tail -f log/_*
1066 ;;
c6cb9d25
MT
1067 "Exit")
1068 break
1069 ;;
24a4a744
MT
1070 esac
1071 done
df5e82b3 1072 ;;
a50d04ab
MT
1073config)
1074 make_config
1075 ;;
6b8cff41 1076*)
a50d04ab 1077 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
6b8cff41
MT
1078 cat doc/make.sh-usage
1079 ;;
3ea75603 1080esac